<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_admin.php                                          ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "messages/".$language_code."/download_messages.php");

	check_admin_security("admin_users");

	$admin_id = get_param("admin_id");
	$permissions = get_permissions();
	$add_admins = get_setting_value($permissions, "add_admins", 0);
	$update_admins = get_setting_value($permissions, "update_admins", 0);
	$remove_admins = get_setting_value($permissions, "remove_admins", 0);

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_admin.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->set_var("admin_admins_href", "admin_admins.php");
	$t->set_var("admin_admin_href",  "admin_admin.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	$t->set_var("PERSONAL_IMAGE_FIELD", PERSONAL_IMAGE_FIELD);

	$r = new VA_Record($table_prefix . "admins");
	$r->return_page = "admin_admins.php";

	$r->add_where("admin_id", INTEGER);

	if(!$admin_id)
	{
		$r->add_textbox("login", TEXT, "Login");
		$r->parameters["login"][REQUIRED] = true;
		$r->parameters["login"][UNIQUE] = true;
		$r->parameters["login"][MIN_LENGTH] = 3;
		$r->add_textbox("password", TEXT, PASSWORD_FIELD);
		$r->parameters["password"][REQUIRED] = true;
		$r->parameters["password"][MIN_LENGTH] = 3;
		$r->add_textbox("confirm", TEXT, CONFIRM_PASS_FIELD);
		$r->change_property("confirm", USE_IN_SELECT, false);
		$r->change_property("confirm", USE_IN_INSERT, false);
		$r->change_property("confirm", USE_IN_UPDATE, false);
		$r->change_property("password", MATCHED, "confirm");
	}

	$r->add_textbox("admin_name", TEXT, "Administartor Name");
	$r->change_property("admin_name", REQUIRED, true);
	$r->add_textbox("personal_image", TEXT, "Administartor Name");
	$r->add_textbox("admin_alias", TEXT, "Initials or alias");
	$r->change_property("admin_alias", UNIQUE, true);
	$r->change_property("admin_alias", REQUIRED, true);

	$privileges = get_db_values("SELECT privilege_id, privilege_name FROM " . $table_prefix . "admin_privileges", "");
	$r->add_select("privilege_id", INTEGER, $privileges, "Privilege Type");
	$r->change_property("privilege_id", REQUIRED, true);

	$r->add_textbox("email", TEXT, "E-mail");
	$r->change_property("email", REQUIRED, true);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);

	$r->add_textbox("signature", TEXT, "Signature");

	$r->events[BEFORE_INSERT] = "encrypt_admin_password";

	$r->operations[INSERT_ALLOWED] = $add_admins;
	$r->operations[UPDATE_ALLOWED] = $update_admins;
	$r->operations[DELETE_ALLOWED] = $remove_admins;
	$r->process();

	if(!$admin_id)
	{
		$t->parse("login_information", false);
	}	

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

	function encrypt_admin_password()
	{
		global $r, $settings;
		$password_encrypt = get_setting_value($settings, "password_encrypt", 0);
		if ($password_encrypt == 1) {
			$r->set_value("password", md5($r->get_value("password")));
		}
	}

?>