<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_credit_card_info.php                               ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("payment_systems");

	$payment_id = get_param("payment_id");
	$setting_type = "credit_card_info_" . $payment_id;
	$sql = " SELECT payment_name FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$payment_name = get_translation($db->f("payment_name"), $language_code);
	} else {
		header ("Location: admin_payment_systems.php");
		exit;
	}

	$message_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$cc_number_options = 
		array( 
			array(0, "Don't save in the database"), 
			array(1, "Save non-encrypted"),
			array(2, "Save encrypted")
		);

	$cc_code_options = 
		array( 
			array(0, "Don't save in the database"), 
			array(1, "Save non-encrypted"),
			array(2, "Save encrypted")
		);

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_credit_card_info.html");
	$t->set_var("admin_credit_card_info_href", "admin_credit_card_info.php");
	$t->set_var("admin_payment_systems_href", "admin_payment_systems.php");
	$t->set_var("admin_payment_system_href", "admin_payment_system.php");
	$t->set_var("admin_order_property_href", "admin_order_property.php");
	$t->set_var("admin_order_help_href", "admin_order_help.php");
	$t->set_var("admin_email_help_href", "admin_email_help.php");
	$t->set_var("payment_id",   $payment_id);
	$t->set_var("payment_name", $payment_name);

	$r = new VA_Record($table_prefix . "credit_card_info");

	$r->add_textbox("intro_text", TEXT);

	// set up html form parameters
	$r->add_checkbox("show_cc_name", INTEGER);
	$r->add_checkbox("show_cc_first_name", INTEGER);
	$r->add_checkbox("show_cc_last_name", INTEGER);
	$r->add_checkbox("show_cc_number", INTEGER);
	$r->add_checkbox("show_cc_start_date", INTEGER);
	$r->add_checkbox("show_cc_expiry_date", INTEGER);
	$r->add_checkbox("show_cc_type", INTEGER);
	$r->add_checkbox("show_cc_issue_number", INTEGER);
	$r->add_checkbox("show_cc_security_code", INTEGER);
	$r->add_checkbox("show_pay_without_cc", INTEGER);
   
	$r->add_checkbox("cc_name_required", INTEGER);
	$r->add_checkbox("cc_first_name_required", INTEGER);
	$r->add_checkbox("cc_last_name_required", INTEGER);
	$r->add_checkbox("cc_number_required", INTEGER);
	$r->add_checkbox("cc_start_date_required", INTEGER);
	$r->add_checkbox("cc_expiry_date_required", INTEGER);
	$r->add_checkbox("cc_type_required", INTEGER);
	$r->add_checkbox("cc_issue_number_required", INTEGER);
	$r->add_checkbox("cc_security_code_required", INTEGER);
	$r->add_checkbox("pay_without_cc_required", INTEGER);

	$r->add_textbox("cc_allowed", TEXT);
	$r->add_textbox("cc_forbidden", TEXT);

	$r->add_checkbox("cc_number_split", INTEGER);
	$r->add_radio("cc_number_security", INTEGER, $cc_number_options);
	$r->add_radio("cc_code_security", INTEGER, $cc_code_options);

	$r->add_checkbox("admin_notification", INTEGER);
	$r->add_textbox("admin_email", TEXT);
	$r->add_textbox("admin_mail_from", TEXT);
	$r->add_textbox("cc_emails", TEXT);
	$r->add_textbox("admin_mail_bcc", TEXT);
	$r->add_textbox("admin_mail_reply_to", TEXT);
	$r->add_textbox("admin_mail_return_path", TEXT);
	$r->add_textbox("admin_subject", TEXT);
	$r->add_radio("admin_message_type", TEXT, $message_types);
	$r->add_textbox("admin_message", TEXT);

	// sms notification settings
	$r->add_checkbox("admin_sms_notification", INTEGER);
	$r->add_textbox("admin_sms_recipient", TEXT, "Administrator SMS Recipient");
	$r->add_textbox("admin_sms_originator", TEXT, "Administator SMS Originator");
	$r->add_textbox("admin_sms_message", TEXT, "Administator SMS Message");

	$r->get_form_values();

	$operation = get_param("operation");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_payment_systems.php";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		if ($r->get_value("admin_sms_notification")) {
			$r->change_property("admin_sms_recipient", REQUIRED, true);
			$r->change_property("admin_sms_message", REQUIRED, true);
		}

		$r->validate();

		if(!strlen($r->errors))
		{
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= $db->tosql($setting_type, TEXT) . ", '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get credit_order_info settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type=" . $db->tosql($setting_type, TEXT) . " AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$sql  = " SELECT property_id, property_name, property_type ";
	$sql .= " FROM " . $table_prefix . "order_custom_properties ";
	$sql .= " WHERE payment_id=" . $db->tosql($payment_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$property_types = array("0" => "Hidden", "4" => "Active");

		do {
			$property_id = $db->f("property_id");
			$property_name = $db->f("property_name");
			$property_type = $property_types[$db->f("property_type")];
			$t->set_var("property_id",   $property_id);
			$t->set_var("property_name", $property_name);
			$t->set_var("property_type", $property_type);

			$t->parse("properties", true);
		} while ($db->next_record());
	} else {
		$t->parse("no_properties", false);
	}


	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>