<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procartz Enterprise 3.8                                       ***
  ***      File:  block_forum_topic_new.php                                ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procartz.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


function forum_topic_new($block_name, $forum_id, $allowed_post_topics)
{
	global $t, $db, $r, $table_prefix;
	global $settings, $page_settings;
	global $date_show_format, $datetime_show_format;

	if (!$allowed_post_topics) {
		return;
	} else if ($allowed_post_topics == 2) {
		// user need to be logged in before viewing forum
		check_user_session();
	}

	$eol = get_eol();
	$errors = false; $fill_error = false;
	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
	$db->query($sql);
	while ($db->next_record()) {
		$forum_settings[$db->f("setting_name")] = $db->f("setting_value");
	}

	$use_random_image = get_setting_value($forum_settings, "use_random_image", 0);

	if (($use_random_image == 2) || ($use_random_image == 1 && !strlen(get_session("session_user_id")))) { 
		$use_validation = true;
	} else {
		$use_validation = false;
	}

	$t->set_file("block_body", "block_forum_topic_new.html");

	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("FORUM_TITLE",    FORUM_TITLE);
	$t->set_var("PREVIEW_TITLE",  PREVIEW_TITLE);
	$t->set_var("MY_ACCOUNT_MSG", MY_ACCOUNT_MSG);
	$t->set_var("NEW_TOPIC_MSG",  NEW_TOPIC_MSG);
	$t->set_var("NO_TOPICS_MSG",  NO_TOPICS_MSG);

	$t->set_var("TOPIC_ADDED_MSG",      TOPIC_ADDED_MSG);
	$t->set_var("DATABASE_ERROR_MSG",   DATABASE_ERROR_MSG);
	$t->set_var("ADD_TOPIC_BUTTON",     ADD_TOPIC_BUTTON);
	                                                   
	$t->set_var("TOPIC_NICKNAME_FIELD", TOPIC_NICKNAME_FIELD);
	$t->set_var("TOPIC_EMAIL_FIELD",    TOPIC_EMAIL_FIELD);
	$t->set_var("TOPIC_NAME_FIELD",     TOPIC_NAME_FIELD);
	$t->set_var("TOPIC_MESSAGE_FIELD",  TOPIC_MESSAGE_FIELD);
	$t->set_var("TOPIC_NOTIFY_FIELD",   TOPIC_NOTIFY_FIELD);
	$t->set_var("VALIDATION_CODE_FIELD",  VALIDATION_CODE_FIELD);

	$t->set_var("PREVIEW_BUTTON", PREVIEW_BUTTON);
	$t->set_var("CLEAR_BUTTON",   CLEAR_BUTTON);
	$t->set_var("RESET_BUTTON",   RESET_BUTTON);

	$provide_info_message = str_replace("{button_name}", ADD_TOPIC_BUTTON, PROVIDE_INFO_MSG);
	$t->set_var("PROVIDE_INFO_MSG", $provide_info_message);
	$t->set_var("ASTERISK_MSG",     ASTERISK_MSG);

	$forum_url = new VA_URL("forum.php");
	$forum_url->add_parameter("u", REQUEST, "u");
	$forum_url->add_parameter("forum_id", REQUEST, "forum_id");

	$t->set_var("forum_topic_new_href", "forum_topic_new.php");
	$t->set_var("rnd", time());

	$r = new VA_Record($table_prefix . "forum");

	$recommended = 
		array( 
			array(1, "Yes"), array(0, "No")
			);

	$r->add_where("thread_id", INTEGER);
	$r->change_property("thread_id", USE_IN_INSERT, true);
	$r->add_hidden("u", INTEGER);
	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("user_name", TEXT);
	$r->add_textbox("user_email", TEXT);
	$r->add_textbox("remote_address", TEXT);
	$r->add_textbox("topic", TEXT);
	$r->add_textbox("friendly_url", TEXT, FRIENDLY_URL_MSG);
	$r->change_property("friendly_url", USE_SQL_NULL, false);
	$r->add_textbox("description", TEXT);
	$r->add_checkbox("email_notification", INTEGER);
	$r->add_textbox("views", INTEGER);
	$r->change_property("views", USE_IN_UPDATE, false);
	$r->add_textbox("replies", INTEGER);
	$r->change_property("replies", USE_IN_UPDATE, false);
	$r->add_textbox("date_added", DATETIME);
	$r->add_textbox("date_modified", DATETIME);
	$r->add_textbox("forum_id", INTEGER);
	$r->add_textbox("validation_number", TEXT, VALIDATION_CODE_FIELD);
	$r->change_property("validation_number", USE_IN_INSERT, false);
	$r->change_property("validation_number", USE_IN_UPDATE, false);
	$r->change_property("validation_number", USE_IN_SELECT, false);
	if ($use_validation) {
		$r->change_property("validation_number", REQUIRED, true);
		$r->change_property("validation_number", SHOW, true);
	} else {
		$r->change_property("validation_number", REQUIRED, false);
		$r->change_property("validation_number", SHOW, false);
	}

	$user_name_class = "normal"; 
	$user_email_class = "normal"; 
	$topic_class = "normal"; 
	$description_class = "normal"; 
	$validation_class = "normal"; 

	$operation = get_param("operation");
	$rnd = get_param("rnd");
	$filter = get_param("filter");
	$remote_address = get_ip();
	$return_page = $forum_url->get_url();
	$session_rnd = get_session("session_rnd");
	  
	$errors_list = "";
	$r->get_form_values();
	$button = get_param("button");
	if($operation && $rnd != $session_rnd)
	{
		set_session("session_rnd", $rnd);	  

		if ($use_validation) { 
			if(!check_image_validation($r->get_value("validation_number"))) {
				$validation_class = "error"; $fill_error = true; $errors = true;
			}
		}

		if($r->is_empty("user_email") || !preg_match(EMAIL_REGEXP, $r->get_value("user_email"))) {
			$user_email_class = "error"; $fill_error = true; $errors = true; 
		}
		if($r->is_empty("user_name")) {
			$user_name_class = "error"; $fill_error = true; $errors = true; 
		}
		if($r->is_empty("topic")) {
			$topic_class = "error"; $fill_error = true; $errors = true; 
		}
		if($r->is_empty("description")) {
			$description_class = "error"; $fill_error = true; $errors = true; 
		}

		if(!$errors) {
			if (check_black_ip()) {
				$errors_list = BLACK_IP_MSG; $errors = true;
			} else if (check_banned_content($r->get_value("description"))) {
				$errors_list = BANNED_CONTENT_MSG; $errors = true;
			}
		}
		
		if ($errors) {
			set_session("session_rnd", "");
		}

		if (!$errors && $button == PREVIEW_BUTTON) {
			$description = nl2br(strip_tags(get_param("description")));
			$t->set_var("description", $description);
			$t->parse("topic_preview", false);
		} else if(!$errors) {
			set_friendly_url();
			$db->query("SELECT MAX(thread_id) FROM " . $table_prefix . "forum");
			$db->next_record();
			$thread_id = $db->f(0) + 1;
			$date_added = va_time();
			$user_id = strlen(get_session("session_user_id")) ? get_session("session_user_id") : 0;

			$r->set_value("thread_id", $thread_id);
			$r->set_value("user_id", $user_id);
			$r->set_value("date_added", $date_added);
			$r->set_value("date_modified", $date_added);
			$r->set_value("remote_address", $remote_address);
			$r->set_value("forum_id", $forum_id);
			$r->set_value("views", 0);
			$r->set_value("replies", 0);
			if($r->insert_record())
			{
				$sql  = " UPDATE " . $table_prefix . "forum_list ";
				$sql .= " SET last_post_added=" . $db->tosql($date_added, DATETIME) . ", threads_number=threads_number+1";
				$sql .= " WHERE forum_id=" . $db->tosql($forum_id, INTEGER);
				$db->query($sql);

				setcookie("cookie_forum_nick", $r->get_value("user_name"), time() + 3600 * 24 * 366);  
				setcookie("cookie_forum_email", $r->get_value("user_email"), time() + 3600 * 24 * 366);

				// send email notification to admin
				if(isset($forum_settings["admin_notification"]))
				{
					$t->set_block("admin_subject", $forum_settings["admin_subject"]);
					$t->set_block("admin_message", $forum_settings["admin_message"]);
					$date_added_string = va_date($datetime_show_format, $date_added);
					// set variables for email
					$r->set_parameters();
					$t->set_var("date_added", $date_added_string);
					$t->set_var("date_modified", $date_added_string);
					$t->set_var("thread_added", $date_added_string);
					$t->set_var("thread_modified", $date_added_string);
					$t->set_var("message_added", $date_added_string);

					$t->set_var("nickname", $r->get_value("user_name"));
					$t->set_var("thread_user_name", $r->get_value("user_name"));
					$t->set_var("message_user_name", $r->get_value("user_name"));

					$t->set_var("message_remote_address", $r->get_value("remote_address"));
					$t->set_var("thread_remote_address", $r->get_value("remote_address"));

					$t->set_var("thread_user_email", $r->get_value("user_email"));
					$t->set_var("message_user_email", $r->get_value("user_email"));

					$t->set_var("topic_description", $r->get_value("description"));
					$t->set_var("topic_message", $r->get_value("description"));
					$t->set_var("message", $r->get_value("description"));
					$t->set_var("message_text", $r->get_value("description"));
			  
					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);

					$mail_to = get_setting_value($forum_settings, "admin_email", $settings["admin_email"]);
					$mail_to = str_replace(";", ",", $mail_to);
					$mail_from = get_setting_value($forum_settings, "admin_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($forum_settings, "cc_emails");
					$mail_bcc = get_setting_value($forum_settings, "admin_mail_bcc");
					$mail_reply_to = get_setting_value($forum_settings, "admin_mail_reply_to");
					$mail_return_path = get_setting_value($forum_settings, "admin_mail_return_path");
					$mail_type = get_setting_value($forum_settings, "admin_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
					@mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}

				$r->empty_values();
				
				header("Location: " . $return_page);
				exit;

			}
			else
			{
				$errors = true;
				$t->parse("db_error", false);;
				set_session("session_rnd", "");
			}
		}
	} else if(strlen(get_session("session_user_id"))) {
		$r->set_value("user_name", get_session("session_user_name"));
		$r->set_value("user_email", get_session("session_user_email"));
	} else {
		$r->set_value("user_name", get_cookie("cookie_forum_nick"));
		$r->set_value("user_email", get_cookie("cookie_forum_email"));
	}

	$t->set_var("user_name_class", $user_name_class);
	$t->set_var("user_email_class", $user_email_class);
	$t->set_var("topic_class", $topic_class);
	$t->set_var("description_class", $description_class);
	$t->set_var("validation_class", $validation_class);

	$r->set_parameters();

	if ($errors) {
		if ($fill_error) {
			$t->parse("fill_error", false);
		}
		if ($errors_list) {
			echo $errors_list;
			$t->set_var("errors_list", $errors_list);
			$t->sparse("errors", false);
		}
		$t->parse("forum_errors", false);
	}

	if(!$errors && $operation && $button == ADD_TOPIC_BUTTON) {
		$t->parse("forum_thanks", false);
	}

	$t->parse("block_body", false);
	$t->parse($block_name, true);

}

?>